<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
  <title> sch-rnd scripting example: quick attr (assisted attribute edit) </title>
  <meta http-equiv="Content-Type" content="text/html;charset=us-ascii">
</head>
<body>
<!-- ******* DO NOT EDIT THIS FILE, it is generated by rosetta_genpages.sh ******* -->
<!-- nopdf="yes"--> &lt;-- back to the <a href="../index.html">index of scripting examples</a>
<h4>quick attr (assisted attribute edit)</h4>
Quick attribute dialog for choosing the value of the tolerance attribute from
a list of a few predefined values (e.g. 1% or 5%) for assisted attribute
editing.
<h5> Example implementation </h5>
<a href="quick_attr.fawk">quick_attr.fawk</a>
<h5> Explanation, step by step </h5>
Creates a quick attribute edit for the "tolerance" attribute and lets the user select from a list of a few common values (0.1%, 1%, 5%, 10%) using a GUI. 
<p> Registers the action quick_attr_tolerance() - because of the name of the action, the property editor and attribute edit dialogs will call this action when the user clicks on assisted edit. 
<p> When quick_attr_tolerance() is called, it first queries the original tolerance value using propget() and checks if the value is present in the array of known tolerances. If so, it saves the index of the value, because the enum widget communicates in integer indices. The same for loop also builds a flat list of values in a string for initializing the enum. 
<p> Next the dialog box is created using the DAD API. The change callback of the enum is made to call our own action qa_tolerance_remember() which is used to remember the last selected value in a script-global variable. After running the dialog box in modal mode (which is required by the quick attr infrastructure), set the new value as symbol attribute using propset(). The return value of the function is as defined by the quick attr infrastructure. 
<p> How to test: 
<ul> 	
<li> load the script 	
<li> place a resistor symbol 	
<li> hover over it and type {a t} 	
<li> select tolerance value, click OK 	
<li> open the attribute editor using {a a} (or from the right click menu on the symbol), look at the tolerance attribute, select it, click the floater 	
<li> clicking the assisted edit button while the tolerance attribute is selected will invoke the script too </ul>
 
</body>
</html>
